
var OTP = function()
{
	var otp = {};
	
	otp.initPage = function()
	{
		// Focs OTP when switching to this tab
		TabControl.addTabActivateListener('settings.otp-tab', otp.setFocus);

		// Accept digits and generate QR code when ENTER is pressed
		Events.addEventHandler('otp', 'keypress', Events.integerOnly);
		Events.doOnEnter('otp', otp.loadQrCode);
	}
	
	otp.setFocus = function()
	{
		Doc.element('otp').focus();
	}
	
	otp.loadQrCode = function()
	{
		var otpValue = Doc.element('otp').value;
		var url = Data.get('otp-data', 'home') + '/OTP.servlet?ID='+App.getSessionId();
		url += '&cmd=DisplayQRCode&otp='+otpValue;
		
		var request = Ajax.getXmlHttpRequest();
		request.open('GET', url, true);
		Ajax.setReadyStateHandler(request, otp.qrCodeLoaded, otp.qrCodeLoaded);
		request.send(null);
	}
	
	
	otp.getResponse = function(request)
	{
		var response;
		var error = false;
		try
		{
			response = JSON.parse(request.responseText);
			if (response.status != 'ok')
			{
				error = response.message || response.stacktrace || 'Unexpected error';
			}
		}
		catch (ex)
		{
			error = ex;
		}
		
		if (error)
		{
			otp.showError(Strings.encodeTags(error));
			return;
		}
		
		return response;
	}
	
	otp.qrCodeLoaded = function(request)
	{
		var response = otp.getResponse(request);
		if (!response) return;
		
		Doc.element('qrcode').src = 'data:image/png;base64,'+response.image;
		Doc.show('qrcode', 'inline');
		Doc.hide('no-qrcode');
		var msg = 'Scan the QR code with your device!<br><br>';
		msg += Strings.encodeTags(response.issuer + ' (' + response.username + ')');
		Doc.element('message').innerHTML = msg;
	}
	
	otp.showError = function(message, focusElement)
	{
		Doc.element('message').innerHTML = '<div class="error">'+Strings.encodeTags(message)+'</div>';
		Doc.element('otp').focus();
		Doc.element('otp').select();
	}

	return otp;
}();

Doc.onLoad(OTP.initPage);

